<template>
  <div class="p-4">
    <hgroup class="mb-3">
      <h1 class="text-xl font-bold mb-1">Our containers</h1>
      <h3>
        Explore a variety of powerful Docker containers for RISC-V, ARM64 and
        AMD64 CPUs.
      </h3>
    </hgroup>
    <UInput
      icon="i-heroicons-magnifying-glass-20-solid"
      size="lg"
      color="white"
      :trailing="false"
      placeholder="Search for a container"
      v-model="search"
    />
    <div v-for="group in sortedGroups" :key="group">
      <h1 class="font-bold text-lg mb-1 mt-3">{{ group }}</h1>
      <div class="flex flex-wrap gap-8">
        <a
          :href="`/containers/${item._id.split(':')[2]}/${item._id
            .split(':')[3]
            .replace('.yml', '')}`"
          v-for="item in groupedContainers[group]"
          :key="item._id"
        >
          <UCard>
            <div class="flex flex-row gap-2 p-2">
              <img
                class="rounded h-14 w-14 mr-2"
                v-show="colorMode.value == 'dark' && item.iconDark"
                :src="item.iconDark"
              />
              <img
                class="rounded h-14 w-14 mr-2"
                v-show="colorMode.value != 'dark' || !item.iconDark"
                :src="item.icon"
              />

              <div>
                <div class="flex gap-2 items-center">
                  <h2 class="font-bold text-xl">{{ item.name || item._id }}</h2>
                  <div class="flex flex-row h-5 gap-1 ml-auto">
                    <template v-for="version in item.versions" :key="version.id" v-if="item.launched ?? true"
                      ><UBadge size="sm" v-if="!version.deprecated">{{
                        version.id
                      }}</UBadge></template
                    >
                    <template v-else>
                      <UBadge size="sm">Coming soon</UBadge>
                    </template>
                  </div>
                  <UBadge v-if="false">New</UBadge>
                </div>
                <span>{{ item.tagline }}</span>
              </div>
            </div>
          </UCard>
        </a>
      </div>
    </div>
    <div v-if="sortedGroups.length > 0">
      <h1 class="font-bold text-lg mb-1 mt-3">And more</h1>
      <div class="flex gap-8">
        <a href="/suggest">
          <UCard>
            <div class="flex flex-row gap-2 p-2">
              <UIcon class="h-14 w-14 mr-2" name="i-heroicon-plus-circle" />
              <div>
                <h2 class="font-bold text-xl">Suggest an app</h2>
                <span>Suggest an app you built or want to have to us.</span>
              </div>
            </div>
          </UCard>
        </a>
      </div>
    </div>
    <div v-else class="flex items-center justify-center mt-6 flex-col">
      <span class="font-bold text-2xl mb-2">No containers found</span>
      <span
        >How about
        <a href="/suggest" class="underline">requesting or building</a> it to
        make it available?</span
      >
    </div>
  </div>
</template>

<script setup lang="ts">
import { useFuse } from "@vueuse/integrations/useFuse";

const prioritizedGroups = ["Base", "Databases", "Languages", "Servers"];

const containers = await queryContent("containers").find();

const colorMode = useColorMode();

const search = ref("");
const searchResults = useFuse(search, containers, {
  fuseOptions: {
    keys: [
      {
        name: "name",
        weight: 3,
      },
      {
        name: "tagline",
        weight: 2,
      },
      {
        name: "description",
        weight: 1,
      },
    ],
    threshold: 0.3,
  },
  matchAllWhenSearchEmpty: true,
});

const groupedContainers = computed(() => {
  return searchResults.results.value.reduce(
    (acc: Record<string, typeof containers>, container) => {
      const name = container.item._id.split(":")[2];
      const humanName = name
        .split("-")
        .map((word) => word[0].toUpperCase() + word.slice(1))
        .join(" ");
      const group = humanName;
      if (!acc[group]) {
        acc[group] = [];
      }
      acc[group].push(container.item);
      return acc;
    },
    {}
  );
});

const sortedGroups = computed(
  (): (keyof (typeof groupedContainers)["value"])[] => {
    // Sort them so that  the prioritized groups are first
    return Object.keys(groupedContainers.value).sort((a, b) => {
      const aIndex = prioritizedGroups.indexOf(a);
      const bIndex = prioritizedGroups.indexOf(b);
      if (aIndex === -1 && bIndex === -1) {
        return 0;
      }
      if (aIndex === -1) {
        return 1;
      }
      if (bIndex === -1) {
        return -1;
      }
      return aIndex - bIndex;
    });
  }
);
</script>
